version: '3.8'

services:
  videofeed_internal:
    build:
      context: .
      dockerfile: Dockerfile
    env_file:
      - .env
    command: /.scripts/start.sh
    volumes:
      - .:/app
      - /var/local/static/${PROJECT_NAME}:/var/local/static/${PROJECT_NAME}
      - /var/local/media/${PROJECT_NAME}/base:/var/local/media/${PROJECT_NAME}/base
    expose:
      - ${PROJECT_PORT}
    depends_on:
      - db
      - celery
      - celery-beat
    networks:
      - crypto-services

  db:
    container_name: db_videofeed
    image: mysql:5.7.22
    restart: always
    env_file:
      - .env
    volumes:
      - .dbdata:/var/lib/mysql
    ports:
      - '33068:3308'
    networks:
      - crypto-services

  celery:
    container_name: celery_videofeed
    build: .
    command: celery -A app worker -l ${LOGGING_LEVEL} -E
    env_file:
      - .env
    networks:
      - crypto-services

  celery-beat:
    container_name: celery_beat_videofeed
    build: .
    command: celery -A app beat -l ${LOGGING_LEVEL}
    env_file:
      - .env
    depends_on:
      - celery
    networks:
      - crypto-services

  flower:
    container_name: flower_videofeed
    build: .
    command: [ "celery", "-A", "app", "--broker=redis://redis:6379", "--result-backend=redis://redis:6379", "flower", "--port=8889" , "--debug=true"]
    env_file:
      - .env
    depends_on:
      - celery
      - celery-beat
    ports:
      - '8889:8889'
    networks:
      - crypto-services

  nginx:
    container_name: videofeed
    build: ./nginx
    ports:
      - '85:85'
    volumes:
      - /var/local/static/${PROJECT_NAME}:/var/local/static/${PROJECT_NAME}
      - /var/local/media/${PROJECT_NAME}/base:/var/local/media/${PROJECT_NAME}/base
    restart: on-failure
    depends_on:
      - videofeed_internal
      - db
    networks:
      - crypto-services

networks:
  crypto-services:
    external: true
